PROGRAM_NAME='Marantz_PD4250D_Main'
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 03/10/2005  AT: 13:15:35              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 12/01/2005  AT: 15:57:58        *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: ??/??/????                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
dvTP      = 10001:1:0           (* NXT-CV12 TOUCH PANEL *)
dvDevice  =  5001:1:0           (* Marantz PD4250D    	*)
vdvDevice = 41001:1:0           (* VIRTUAL DEVICE       *)

// CABLE NEEDED IS FG#756-04

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

INTEGER nCHAN_BTN[] =                   // CHANNEL BUTTONS ON TOUCH PANEL
{
	1,	//1-	POWER OFF
	2,	//2-	POWER ON
	3,	//3-	INPUT VIDEO 1
	4,	//4-	INPUT VIDEO 2
	5,	//5-	INPUT VIDEO 3
	6,	//6-	INPUT HD 1
	7,	//7-	INPUT HD 2
	8,	//8-	INPUT HD 3
	9,	//9-	
	10,	//10-	
	11,	//11-	
	12,	//12-	MUTE TOGGLE
	13,	//13-	CONTRAST UP
	14,	//14-	CONTRAST DN	
	15,	//15-	BRIGHTNESS UP
	16,	//16-	BRIGHTNESS DN
	17,	//17-	COLOR UP
	18,	//18-	COLOR DN
	19,	//19-	TINT UP
	20,	//20-	TINT DN
	21,	//21-	SHARPNESS UP
	22,	//22-	SHARPNESS DN
	23,	//23- 	ASPECT RATIO STADIUM
	24,	//24-	ASPECT RATIO ZOOM
	25,	//25-	ASPECT RATIO NORMAL
	26,	//26-	ASPECT RATIO ANAMORPHIC
	27,	//27-	ASPECT RATIO 14:9
	28,	//28-	ASPECT RATIO 2.35:1
	29,	//29-	INPUT COMPUTER 1
	30,	//30-	
	31,	//31-	
	32,	//32-	CONTRAST LEVEL
	33,	//33-	BRIGHTNESS LEVEL
	34,	//34-	COLOR LEVEL
	35,	//35-	TINT LEVEL
	36	//36-	SHARPNESS LEVEL
}

INTEGER nTXT_BTN[] =                    // TEXT BUTTONS ON TOUCH PANEL
{
   1
}
VOLATILE INTEGER nLVL_BTN[] =			// LEVEL BUTTONS
{
	1,	//	VOLUME
	2,	//	BRIGHTNESS
	3,	//	COLOR
	4,	//	CONTRAST
	5,	//	SHARPNESS
	6	//	TINT
}
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

DEFINE_MODULE 'Marantz_PD4250D_Comm_v1_0_0' DuetCode(vdvDevice, dvDevice)
DEFINE_MODULE 'Marantz_PD4250D_UI'   TP1(vdvDevice, dvTP, nCHAN_BTN, nTXT_BTN, nLVL_BTN)
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)