MODULE_NAME='Marantz_PD4250D_UI' (DEV vdvDevice, DEV dvTP, INTEGER nCHAN_BTN[], INTEGER nTXT_BTN[], INTEGER nLVL_BTN[])
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 03/10/2005  AT: 13:15:35              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 12/01/2005  AT: 15:58:06        *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: ??/??/????                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

#INCLUDE 'SNAPI.AXI'
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR sVERSION[5] = ''   // STORES NETLINX COMM MODULE VERSION NUMBER
VOLATILE INTEGER nDEBUG = 0      // TRACKS THE ON/OFF STATE OF DEBUG MSGS SENT TO THE TELNET SESSION
VOLATILE CHAR cCOMMAND[10][10]
VOLATILE INTEGER nINPUT
VOLATILE INTEGER nASPECT

VOLATILE INTEGER nBRIGHTNESS_LEVEL_BUSY = 0
VOLATILE INTEGER nBRIGHTNESS_LEVEL_FROM_PANEL = 0
VOLATILE INTEGER nBRIGHTNESS_LEVEL_FROM_DEVICE = 0

VOLATILE INTEGER nCONTRAST_LEVEL_BUSY = 0
VOLATILE INTEGER nCONTRAST_LEVEL_FROM_PANEL = 0
VOLATILE INTEGER nCONTRAST_LEVEL_FROM_DEVICE = 0

VOLATILE INTEGER nCOLOR_LEVEL_BUSY = 0
VOLATILE INTEGER nCOLOR_LEVEL_FROM_PANEL = 0
VOLATILE INTEGER nCOLOR_LEVEL_FROM_DEVICE = 0

VOLATILE INTEGER nTINT_LEVEL_BUSY = 0
VOLATILE INTEGER nTINT_LEVEL_FROM_PANEL = 0
VOLATILE INTEGER nTINT_LEVEL_FROM_DEVICE = 0

VOLATILE INTEGER nSHARPNESS_LEVEL_BUSY = 0
VOLATILE INTEGER nSHARPNESS_LEVEL_FROM_PANEL = 0
VOLATILE INTEGER nSHARPNESS_LEVEL_FROM_DEVICE = 0


(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
//
// Function : fnPARSE()
// Purpose  : STRING PARSING USING A DELIMITER
// Params   : CHAR cDELIMITER[], CHAR cSTRING[], CHAR cNEW_STRING[][]
// Return   : nCOUNTER
// Notes    : THIS FUNCTION PARSES A STRING USING A DELIMITER PASSED BY THE USER. 
//            MAXIMUM OF 10 PARAMETERS OF LENGTH 50 EACH- DELIMITER CAN HAVE LENGTH 1 OR 2.
//            THIS FUNCTION RETURNS THE NUMBER OF PARAMETERES PARSED. cNEW_STRING CONTAINS THE PARSED INFO.
DEFINE_FUNCTION INTEGER fnPARSE(CHAR cDELIMITER[2], CHAR cSTRING[500], CHAR cNEW_STRING[11][50])
{
	STACK_VAR INTEGER nCOUNTER
	nCOUNTER=0
	WHILE(nCOUNTER<=10)
	{
		IF(FIND_STRING(cSTRING,"cDELIMITER",1))  
		{
			cNEW_STRING[nCOUNTER+1]=REMOVE_STRING(cSTRING,"cDELIMITER",1)
			SET_LENGTH_STRING(cNEW_STRING[nCOUNTER+1],LENGTH_STRING(cNEW_STRING[nCOUNTER+1])-LENGTH_STRING(cDELIMITER))
			nCOUNTER++
		}
		ELSE
		{
			cNEW_STRING[nCOUNTER+1]=cSTRING
			IF(LENGTH_STRING(cSTRING))
				nCOUNTER++
			BREAK  
		}
	}
	RETURN nCOUNTER
}	

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START
CREATE_LEVEL dvTP, nLVL_BTN[2], nBRIGHTNESS_LEVEL_FROM_PANEL
CREATE_LEVEL vdvDevice, BRIGHT_LVL, nBRIGHTNESS_LEVEL_FROM_DEVICE

CREATE_LEVEL dvTP, nLVL_BTN[4], nCONTRAST_LEVEL_FROM_PANEL
CREATE_LEVEL vdvDevice, CONTRAST_LVL, nCONTRAST_LEVEL_FROM_DEVICE

CREATE_LEVEL dvTP, nLVL_BTN[3], nCOLOR_LEVEL_FROM_PANEL
CREATE_LEVEL vdvDevice, COLOR_LVL, nCOLOR_LEVEL_FROM_DEVICE

CREATE_LEVEL dvTP, nLVL_BTN[6], nTINT_LEVEL_FROM_PANEL
CREATE_LEVEL vdvDevice, TINT_LVL, nTINT_LEVEL_FROM_DEVICE

CREATE_LEVEL dvTP, nLVL_BTN[5], nSHARPNESS_LEVEL_FROM_PANEL
CREATE_LEVEL vdvDevice, SHARP_LVL, nSHARPNESS_LEVEL_FROM_DEVICE

(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT


DATA_EVENT[vdvDEVICE]
{
	COMMAND:
	{
		STACK_VAR CHAR DATUM[30]
		
		IF(nDEBUG >= 3)
		{
			send_string 0, "'UI/Virtual Device 1 received from Comm: ',data.text"
		}
        DATUM  = remove_string(data.text, '-', 1)
        
        SWITCH(DATUM)
		{
			// FIND MATCHING STRING AND PARSE REST OF MESSAGE. PROVIDE FEEDBACK TO THE 
			// TOUCH PANEL.
			CASE 'ASPECT-':
			{
				IF(DATA.TEXT == 'STADIUM')
					nASPECT = 1
				ELSE IF(DATA.TEXT == 'ZOOM')
					nASPECT = 2
				ELSE IF(DATA.TEXT == 'NORMAL')
					nASPECT = 3
				ELSE IF(DATA.TEXT == 'ANAMORPHIC')
					nASPECT = 4
				ELSE IF(DATA.TEXT == 'CUSTOM')
					nASPECT = 5
				ELSE IF(DATA.TEXT == 'ANAMORPHIC2')
					nASPECT = 6
			}
			CASE 'DEBUG-': 
			{	nDEBUG = ATOI(DATA.TEXT) 
				IF (nDebug >= 3) 
					SEND_STRING 0, "'Debug messages are now on.'"
                ELSE IF(nDEBUG < 3)
					SEND_STRING 0, "'Debug messages are now off.'"
			}
			CASE 'INPUT-':
			{
				fnPARSE(',',DATA.TEXT,cCOMMAND)
				IF(cCOMMAND[1] == 'VIDEO')
				{
					IF(cCOMMAND[2] == '1')
						nINPUT = 1
					ELSE IF(cCOMMAND[2] == '2')
						nINPUT = 2
					ELSE IF(cCOMMAND[2] == '3')
						nINPUT = 3
				}		
				ELSE IF(cCOMMAND[1] == 'HDTV')		
				{
					IF(cCOMMAND[2] == '1')
						nINPUT = 4
					ELSE IF(cCOMMAND[2] == '2')
						nINPUT = 5
					ELSE IF(cCOMMAND[2] == '3')
						nINPUT = 6
				}
				ELSE IF(cCOMMAND[1] == 'COMPUTER')		
				{
					IF(cCOMMAND[2] == '1')
						nINPUT = 7
//					ELSE IF(cCOMMAND[2] == '2')
//						nINPUT = 8
//					ELSE IF(cCOMMAND[2] == '3')
//						nINPUT = 9
				}
			}
			CASE 'VERSION-': 
			{
				sVERSION = DATA.TEXT 
			}
		}// END SWITCH(datum)
	}// END COMMAND
}// END DATA_EVENT[vdvDEVICE]


DATA_EVENT[dvTP]
{
	ONLINE: 
	{
		SEND_COMMAND dvTP, "'@PPX'"
	}
}// END DATA_EVENT[dvTP]

BUTTON_EVENT[dvTP, nCHAN_BTN]
{
	PUSH:
	{
		STACK_VAR INTEGER nBTN
		
		nBTN = GET_LAST(nCHAN_BTN)
		SWITCH(nBTN)
		{
			CASE 1: 	//POWER OFF
			{
				PULSE[vdvDEVICE,PWR_OFF]
			}
			CASE 2:		//POWER ON
			{
				PULSE[vdvDEVICE,PWR_ON]
			}
			CASE 3:		//INPUT VIDEO 1
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-VIDEO,1'
			}
			CASE 4:		//INPUT VIDEO 2
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-VIDEO,2'
			}
			CASE 5:		//INPUT VIDEO 3
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-VIDEO,3'
			}
			CASE 6:		//INPUT HD 1
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-HDTV,1'
			}
			CASE 7:		//INPUT HD 2
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-HDTV,2'
			}
			CASE 8:		//INPUT HD 3
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-HDTV,3'
			}	
			CASE 12:	//MUTE TOGGLE
			{
				PULSE[vdvDEVICE, VOL_MUTE]
			}
			CASE 13:	//CONTRAST UP
			{
				PULSE[vdvDEVICE,CONTRAST_UP]
			}
			CASE 14:	//CONTRAST DN
			{
				PULSE[vdvDEVICE,CONTRAST_DN]	
			}
			CASE 15:	//BRIGHTNESS UP
			{
				PULSE[vdvDEVICE,BRIGHT_UP]
			}
			CASE 16:	//BRIGHTNESS DN
			{
				PULSE[vdvDEVICE,BRIGHT_DN]
			}
			CASE 17:	//COLOR UP
			{
				PULSE[vdvDEVICE,COLOR_UP]
			}
			CASE 18:	//COLOR DN
			{
				PULSE[vdvDEVICE,COLOR_DN]
			}
			CASE 19:	//TINT UP
			{
				PULSE[vdvDEVICE,TINT_UP]
			}
			CASE 20:	//TINT DN
			{
				PULSE[vdvDEVICE,TINT_DN]
			}
			CASE 21:	//SHARPNESS UP
			{
				PULSE[vdvDEVICE,SHARP_UP]
			}
			CASE 22:	//SHARPNESS DN
			{
				PULSE[vdvDEVICE,SHARP_DN]
			}
			CASE 23:	//ASPECT RATIO STADIUM
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-STADIUM'
			}
			CASE 24:	//ASPECT RATIO ZOOM
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-ZOOM'
			}
			CASE 25:	//ASPECT RATIO NORMAL
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-NORMAL'
			}
			CASE 26:	//ASPECT RATIO ANAMORPHIC
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-ANAMORPHIC'
			}
			CASE 27:	//ASPECT RATIO 14:9
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-CUSTOM'
			}
			CASE 28:	//ASPECT RATIO 2.35:1
			{
				SEND_COMMAND vdvDEVICE, 'ASPECT-ANAMORPHIC2'
			}	
			CASE 29:	//INPUT COMPUTER 1
			{
				SEND_COMMAND vdvDEVICE, 'INPUT-COMPUTER,1'
			}
//			CASE 30:	//INPUT COMPUTER 2
//			{
//				SEND_COMMAND vdvDEVICE, 'INPUT-COMPUTER,2'
//			}
//			CASE 31:	//INPUT COMPUTER 3
//			{
//				SEND_COMMAND vdvDEVICE, 'INPUT-COMPUTER,3'
//			}
			CASE 32:	//CONTRAST LEVEL
			{
				nCONTRAST_LEVEL_BUSY = 1
				SEND_LEVEL vdvDEVICE, CONTRAST_LVL, nCONTRAST_LEVEL_FROM_PANEL
			}
			CASE 33:	//BRIGHTNESS LEVEL
			{
				nBRIGHTNESS_LEVEL_BUSY = 1
				SEND_LEVEL vdvDEVICE, BRIGHT_LVL, nBRIGHTNESS_LEVEL_FROM_PANEL
			}
			CASE 34:	//COLOR LEVEL
			{
				nCOLOR_LEVEL_BUSY = 1
				SEND_LEVEL vdvDEVICE, COLOR_LVL, nCOLOR_LEVEL_FROM_PANEL			
			}
			CASE 35:	//TINT LEVEL
			{
				nTINT_LEVEL_BUSY = 1
				SEND_LEVEL vdvDEVICE, TINT_LVL, nTINT_LEVEL_FROM_PANEL			
			}
			CASE 36:	//SHARPNESS LEVEL
			{
				nSHARPNESS_LEVEL_BUSY = 1
				SEND_LEVEL vdvDEVICE, SHARP_LVL, nSHARPNESS_LEVEL_FROM_PANEL			
			}
		}// END SWITCH(nBTN)
	}// END PUSH
	HOLD[5,REPEAT]:
	{
		STACK_VAR INTEGER nBTN
		
		nBTN = GET_LAST(nCHAN_BTN)		
		SWITCH(nBTN)
		{
			CASE 13:	//CONTRAST UP
			{
				PULSE[vdvDEVICE,CONTRAST_UP]
			}
			CASE 14:	//CONTRAST DN
			{
				PULSE[vdvDEVICE,CONTRAST_DN]	
			}
			CASE 15:	//BRIGHTNESS UP
			{
				PULSE[vdvDEVICE,BRIGHT_UP]
			}
			CASE 16:	//BRIGHTNESS DN
			{
				PULSE[vdvDEVICE,BRIGHT_DN]
			}
			CASE 17:	//COLOR UP
			{
				PULSE[vdvDEVICE,COLOR_UP]
			}
			CASE 18:	//COLOR DN
			{
				PULSE[vdvDEVICE,COLOR_DN]
			}
			CASE 19:	//TINT UP
			{
				PULSE[vdvDEVICE,TINT_UP]
			}
			CASE 20:	//TINT DN
			{
				PULSE[vdvDEVICE,TINT_DN]
			}
			CASE 21:	//SHARPNESS UP
			{
				PULSE[vdvDEVICE,SHARP_UP]
			}
			CASE 22:	//SHARPNESS DN
			{
				PULSE[vdvDEVICE,SHARP_DN]
			}
		}
	}
	RELEASE:
	{
		STACK_VAR INTEGER nBTN
		
		nBTN = GET_LAST(nCHAN_BTN)		
		SWITCH(nBTN)
		{
			CASE 32:	//CONTRAST LEVEL
			{
				nCONTRAST_LEVEL_BUSY = 0
				SEND_LEVEL dvTP, nLVL_BTN[4], nCONTRAST_LEVEL_FROM_DEVICE 			
			}
			CASE 33:	//BRIGHTNESS LEVEL
			{
				nBRIGHTNESS_LEVEL_BUSY = 0
				SEND_LEVEL dvTP, nLVL_BTN[2], nBRIGHTNESS_LEVEL_FROM_DEVICE 
			}
			CASE 34:	//COLOR LEVEL
			{
				nCOLOR_LEVEL_BUSY = 0
				SEND_LEVEL dvTP, nLVL_BTN[3], nCOLOR_LEVEL_FROM_DEVICE 				
			}
			CASE 35:	//TINT LEVEL
			{
				nTINT_LEVEL_BUSY = 0
				SEND_LEVEL dvTP, nLVL_BTN[6], nTINT_LEVEL_FROM_DEVICE 				
			}
			CASE 36:	//SHARPNESS LEVEL
			{
				nSHARPNESS_LEVEL_BUSY = 0
				SEND_LEVEL dvTP, nLVL_BTN[5], nSHARPNESS_LEVEL_FROM_DEVICE 	
			}
		}
	}
}// END BUTTON_EVENT[dvTP, nCHAN_BTN]

LEVEL_EVENT[dvTP, nLVL_BTN[1]]
{	
	CANCEL_WAIT 'VOL_WAIT'
	WAIT 5 'VOL_WAIT'
	{
		SEND_LEVEL vdvDEVICE,VOL_LVL,LEVEL.VALUE 
	}
}
LEVEL_EVENT[dvTP, nLVL_BTN[2]]
{	
	IF(nBRIGHTNESS_LEVEL_BUSY)
	{
		SEND_LEVEL vdvDEVICE, BRIGHT_LVL, nBRIGHTNESS_LEVEL_FROM_PANEL 
	}
}
LEVEL_EVENT[dvTP, nLVL_BTN[3]]
{	
	IF(nCOLOR_LEVEL_BUSY)
	{
		SEND_LEVEL vdvDEVICE, COLOR_LVL, nCOLOR_LEVEL_FROM_PANEL 
	}
}
LEVEL_EVENT[dvTP, nLVL_BTN[4]]
{	
	IF(nCONTRAST_LEVEL_BUSY)
	{
		SEND_LEVEL vdvDEVICE, CONTRAST_LVL, nCONTRAST_LEVEL_FROM_PANEL 
	}
}
LEVEL_EVENT[dvTP, nLVL_BTN[5]]
{
	IF(nSHARPNESS_LEVEL_BUSY)
	{	
		SEND_LEVEL vdvDEVICE, SHARP_LVL, nSHARPNESS_LEVEL_FROM_PANEL 
	}
}
LEVEL_EVENT[dvTP, nLVL_BTN[6]]
{
	IF(nTINT_LEVEL_BUSY)
	{	
		SEND_LEVEL vdvDEVICE, TINT_LVL, nTINT_LEVEL_FROM_PANEL 
	}
}


LEVEL_EVENT[vdvDEVICE, VOL_LVL]
{
	SEND_LEVEL dvTP,nLVL_BTN[1],LEVEL.VALUE 
}
LEVEL_EVENT[vdvDEVICE, BRIGHT_LVL]
{
	IF(!nBRIGHTNESS_LEVEL_BUSY)
	{
		SEND_LEVEL dvTP, nLVL_BTN[2], nBRIGHTNESS_LEVEL_FROM_DEVICE 
	}
}
LEVEL_EVENT[vdvDEVICE, COLOR_LVL]
{
	IF(!nCOLOR_LEVEL_BUSY)
	{
		SEND_LEVEL dvTP,nLVL_BTN[3], nCOLOR_LEVEL_FROM_DEVICE 
	}
}
LEVEL_EVENT[vdvDEVICE, CONTRAST_LVL]
{
	IF(!nCONTRAST_LEVEL_BUSY)
	{
		SEND_LEVEL dvTP,nLVL_BTN[4], nCONTRAST_LEVEL_FROM_DEVICE
	}
}
LEVEL_EVENT[vdvDEVICE, SHARP_LVL]
{
	IF(!nSHARPNESS_LEVEL_BUSY)
	{
		SEND_LEVEL dvTP,nLVL_BTN[5], nSHARPNESS_LEVEL_FROM_DEVICE 
	}
}
LEVEL_EVENT[vdvDEVICE, TINT_LVL]
{
	IF(!nTINT_LEVEL_BUSY)
	{
		SEND_LEVEL dvTP,nLVL_BTN[6], nTINT_LEVEL_FROM_DEVICE 
	}
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

[dvTP,nCHAN_BTN[1]] 	=!	[vdvDEVICE, POWER_FB]
[dvTP,nCHAN_BTN[2]] 	=	[vdvDEVICE, POWER_FB]

[dvTP,nCHAN_BTN[3]] 	=	nINPUT == 1
[dvTP,nCHAN_BTN[4]] 	=	nINPUT == 2
[dvTP,nCHAN_BTN[5]] 	=	nINPUT == 3
[dvTP,nCHAN_BTN[6]] 	=	nINPUT == 4
[dvTP,nCHAN_BTN[7]] 	=	nINPUT == 5
[dvTP,nCHAN_BTN[8]] 	=	nINPUT == 6
[dvTP,nCHAN_BTN[29]] 	=	nINPUT == 7
//[dvTP,nCHAN_BTN[30]] 	=	nINPUT == 8
//[dvTP,nCHAN_BTN[31]] 	=	nINPUT == 9

[dvTP,nCHAN_BTN[11]]	=! 	[vdvDEVICE,VOL_MUTE_FB]
[dvTP,nCHAN_BTN[12]]	= 	[vdvDEVICE,VOL_MUTE_FB]

[dvTP,nCHAN_BTN[23]] 	=	nASPECT == 1
[dvTP,nCHAN_BTN[24]]	=	nASPECT == 2
[dvTP,nCHAN_BTN[25]] 	=	nASPECT == 3
[dvTP,nCHAN_BTN[26]] 	=	nASPECT == 4
[dvTP,nCHAN_BTN[27]] 	=	nASPECT == 5
[dvTP,nCHAN_BTN[28]]	=	nASPECT == 6


[dvTP,251] = [vdvDEVICE, 251]
[dvTP,252] = [vdvDEVICE, 252]
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)